/* SOD64 the Stack Oriented Design computer.
   Copyright 1994 L.C. Benschop, Eindhoven, The Netherlands.
   The program is released under the GNU General Public License version 2.
   There is NO WARRANTY.
*/

#define UNS8  unsigned char
#define INT64 long int
#define UNS64 unsigned long int

#define MEMSIZE 1*1024*1024 /* must be a power of two */
#define MEMMASK MEMSIZE-1   /* mask for addresses to force them into range */

extern UNS8 mem[];

extern UNS64 save_sp,save_ip,save_rp;

#define CELL(reg) (*(UNS64*)(mem+((reg)&MEMMASK)))
#define CELLMASK (~7)

#ifdef BIG_ENDIAN
 #define BYTEMASK 0
#else
 #define BYTEMASK 7
#endif

#define BYTE(reg) mem[((reg)&MEMMASK)^BYTEMASK]

void swap_mem(UNS64,UNS64);
void do_os(void);
void do_special(UNS64);
void virtual_machine(void);

#ifdef _WIN32
#  define TIMER GetTickCount
#else
#  define TIMER ticks
#endif
